class obrazky{
  constructor(){
    this.navesti = new Array(5);
    //TODO: lego a kostky vyšlrtnout, až bude 1-9 
    this.navesti[0] = {"zkratka": "digi", "nazev": "Digitálky"};
    this.navesti[1] = {"zkratka": "hodiny", "nazev": "Hodiny"};
    this.navesti[2] = {"zkratka": "karta", "nazev": "Karty"};
    //this.navesti[3] = {"zkratka": "kostka", "nazev": "Kostky"};
    this.navesti[3] = {"zkratka": "lego", "nazev": "Lego"};
    this.splneno = [0,0,0];
    
    this.tmp = new Array(3);
    this.tmp["indexy"] = [0,1,2,3];                                                    //pomocna promenna urcujici obrazky, co se budou vypisovat
    this.tmp["obrazky"] = [0,1,2,3,4,5];                                               //pomocna promenna urcujici poradi obrazku
    this.tmp["vypis"] = [0,1,2];                                                       //pomocna promennna urcujici vypisovani hromadek 
    //todo - odebrat z cisel 1-9 3 nahodne
    this.tmp["hodnoty"] = [1,2,3,4,5,6,7,8,9];
    let ran_cislo = 0;
    for(var i=0; i<3;i++){
      ran_cislo = random_int(0,8-i);
      this.tmp["hodnoty"].splice(ran_cislo, 1); 
    }
  }           
  
  prohazej(co){
    let tmp_var, tmp_index;
    for(let x = 0; x<this.tmp[co].length; x++){
      tmp_index = Math.floor(Math.random()*this.tmp[co].length);
      tmp_var = this.tmp[co][tmp_index];
      this.tmp[co][tmp_index] = this.tmp[co][x]; 
      this.tmp[co][x] = tmp_var;   
    } 
  }
  
  vytvor_hromadky(pocet){
    let obal, element;
    let rodic = document.getElementById('karticky');
    rodic.innerHTML = "";
    for(let i=0; i<pocet; i++){
      obal = document.createElement('div');
      this.prohazej('hodnoty');                                             
      for(let x=0;x<this.tmp["obrazky"].length;x++){
        element = document.createElement('img');                                                     //
        element.src = "image/"+this.navesti[this.tmp["indexy"][this.tmp["vypis"][i]]]["zkratka"]+""+(this.tmp["hodnoty"][x])+".jpg";
        element.alt = "obrazek_"+this.tmp["hodnoty"][x];
        element.dataset['id'] = this.navesti[this.tmp["indexy"][this.tmp["vypis"][i]]]["zkratka"]+""+(this.tmp["hodnoty"][x]);
        element.dataset['index'] = this.tmp["vypis"][i];
        element.setAttribute("class","drag");
        obal.appendChild(element);
      }
      rodic.appendChild(obal);        
    }  
  }                     
}


class tabulka{
  constructor(){
    let tabulka = document.createElement('table');
    tabulka.id = "evidujeme_pr2";
    let header = tabulka.createTHead();
    let radek = header.insertRow(0);
    let bunka = radek.insertCell(0);
    window.bunka_radek = [0,0,0];           //je to globalni, ale "zabalené"
    bunka.innerHTML = "Název"; 
    bunka = radek.insertCell(1);
    bunka.innerHTML = "Obrázky"
    bunka.setAttribute("colspan","6");     
    let rodic = document.getElementById('tabulka');
    rodic.innerHTML = "";
    rodic.appendChild(tabulka);
    this.zadani  = Math.round(Math.random());    //1=sestupne, 0=vzestupne
  }
  
  pridejZadani(obrazky){
   let str_serazeni;
   let popis = document.getElementById('pr_zadani');
   if(this.zadani == 1) str_serazeni = "sestupně";
   else                 str_serazeni = "vzestupně"; 
   //vypis hodnot v balickach
   obrazky.prohazej("hodnoty");
   let vypis_hodnot = "";
   for(let x=0; x<6; x++){
    if(x==4)            vypis_hodnot += obrazky.tmp["hodnoty"][x]+" a ";
    else if(x==5)       vypis_hodnot += obrazky.tmp["hodnoty"][x];
    else                vypis_hodnot += obrazky.tmp["hodnoty"][x] + ", ";
   }
   
   popis.innerHTML = "Pro zapisování dat&nbsp;do tabulky musíš nejprve znát pravidla evidence. K&nbsp;tomu slouží popis tabulky pomocí záhlaví. Před sebou máš tabulku, která&nbsp;má tři řádky začínající názvem přidružených obrázků. Dovedeš&nbsp;je tam správně <strong>"+str_serazeni+"</strong> seřadit, když hodnoty v balíčkách jsou: "+ vypis_hodnot +"?";
  
  //prvek s napovedou 
  let napoveda = document.createElement("sub");
  napoveda.innerHTML = "(Nápověda)";
  napoveda.addEventListener("click", function(){
    show_hide('pomoc_karta');
  });  
  popis.appendChild(napoveda);
  
  let text_napoveda = document.getElementById("pomoc_karta");
  text_napoveda.classList.add("help");
  text_napoveda.style.display = "none";
  text_napoveda.innerHTML = "Pokud máš doplňovat obrázky karet, eso (karta&nbsp;s písmenem&nbsp;A) představuje&nbsp;v takovém případě nejnižší hodnotou.";
  
  }
  
  pridejRadky(obrazky,pocet){
    let radek, bunka;
    let tabulka = document.getElementById('evidujeme_pr2');  
    let telo = tabulka.createTBody();
    for(let i=0;i<pocet;i++){
      radek = telo.insertRow(i);
      let tmp_id = obrazky.navesti[obrazky.tmp["indexy"][i]]['zkratka'];
      let tmp_pole_hodnot = obrazky.tmp["hodnoty"];
      radek.id = tmp_id;
      /* bunka s nazvem */
      bunka = radek.insertCell(0);
      bunka.innerHTML = obrazky.navesti[obrazky.tmp["indexy"][i]]['nazev'];
      /* vlozeni potrebnych bunek */
      var xy = 0;
      do{
      //for(let x = 1; x<=6; x++){
        xy++;
        let bunka = document.createElement('td'); 
        //nastavuji class a id
        if(this.zadani == 1) bunka.dataset['id'] = tmp_id+(tmp_pole_hodnot[6-xy]);
        else                 bunka.dataset['id'] = tmp_id+(tmp_pole_hodnot[xy-1]);        
        bunka.setAttribute('class','drop');
        jQuery(bunka).droppable({
            drop: function( event, ui ){
              event.preventDefault();
              if(event.target.dataset['id'] != "")
                if(ui.draggable[0].dataset['id'] == event.target.dataset['id']){
                  event.target.appendChild(ui.draggable[0]);
                  jQuery(ui.draggable[0]).draggable("destroy");
                  ui.draggable[0].removeAttribute("class");
                  jQuery(event.target).droppable("destroy");
                  image.splneno[ui.draggable[0].dataset['index']]++;
                  if(image.splneno[ui.draggable[0].dataset['index']] == 6)
                    print_modal("modal","ok");
                }else{
                  jQuery(ui.draggable[0]).draggable({
                    revert: true
                  });
                }
              }
            });
        radek.appendChild(bunka);   
      }while(xy < 6)  
      
      /*
      bunka = radek.insertCell(1);
      bunka.setAttribute("colspan","6");
      let input = document.createElement('input');
      input.type = "submit";
      input.value = "+";
      input.title = "Přidej buňku";
      input.setAttribute('class','cap2');       
      //funkce pridavajici bunku do daneho radku
      input.addEventListener("click", function(){ 
          if(bunka_radek[i] < 6){
            bunka_radek[i]++;
            //vkladam bunku
            let bunka = document.createElement('td');
            //nastavuji class a id
            bunka.dataset['id'] = tmp_id+(7-bunka_radek[i]);
            bunka.setAttribute('class','drop');
            //nastavuji drop
            jQuery(bunka).droppable({
            drop: function( event, ui ){
              event.preventDefault();
              if(event.target.dataset['id'] != "")
                if(ui.draggable[0].dataset['id'] == event.target.dataset['id']){
                  event.target.appendChild(ui.draggable[0]);
                  jQuery(ui.draggable[0]).draggable("destroy");
                  ui.draggable[0].removeAttribute("class");
                  jQuery(event.target).droppable("destroy");
                  image.splneno[ui.draggable[0].dataset['index']]++;
                  if(image.splneno[ui.draggable[0].dataset['index']] == 6)
                    print_modal("modal","ok");
                }else{
                  jQuery(ui.draggable[0]).draggable({
                    revert: true
                  });
                }
              }
            });
            //zmensuji colspan
            this.parentElement.colSpan--;
            this.parentElement.parentElement.appendChild(bunka);               
          }
          //u predposledniho to zavolam manualne znovu
          if(bunka_radek[i] == 5){
            this.click();             
          }
          
          if(bunka_radek[i] == 6){        
            this.parentElement.classList.add('w3-hide');                          
          }              
          //jinak by se tam neměl dostat
      });   
      bunka.appendChild(input);
      */
    }
  }  
}

     
/////////////
//hlavni kod
////////////
//priprava obrazku
var image = new obrazky();
image.prohazej('indexy');

//vytvoreni tabulky
var table = new tabulka();
table.pridejRadky(image,3);
table.pridejZadani(image);

//vytvoreni hromadky  
image.prohazej("vypis");
image.vytvor_hromadky(3);

/* draggable */
jQuery(".drag").draggable({ revert: "invalid" });